if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[up_EntryList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[up_EntryList]
GO

CREATE    Proc up_EntryList
@ixPage int, --valid number should start from  1, 0 means a indicator for the latest page
@lPageUnit int --e.g. 15
as
SET NOCOUNT ON
------------------------------------
/*
CreateDate: 		2006-03-05
CreateBy:		DEXLEAP.COM
CreatePurpose:
(1)List entries under a given ixPage
RevisDate:
ReviseBy:
ReviseReason:
*/
------------------------------------
------------------------------------
--Customize Declaration
------------------------------------
Declare
	@ixSortPageMin int,
	@ixSortPageMax int,
	@cntEntry int,
	@maxPageNum int

Create table #tblTmpEntryListPaging
(
	ixSort int IDENTITY (1, 1) NOT NULL ,
	ixArchiveEntry int

)

------------------------------------
--Customize Initialize
------------------------------------
--fill the paging table 
Insert into #tblTmpEntryListPaging
(
	ixArchiveEntry
)
Select
	ixArchiveEntry
From
	tdatArchiveEntry
order by
	ixArchiveEntry
--@ixPage should start from 1, if it's 0, it means the latest page
If @ixPage = 0
Begin
	Select 
		@cntEntry = count(ixSort)
	From
		#tblTmpEntryListPaging	
	--latest (biggest) page
	--denpends on the division calculation
	if @cntEntry%@lPageUnit = 0
	Begin
		Select 
			@ixPage = @cntEntry/@lPageUnit 
	End 
	Else
	Begin
		Select
			@ixPage = @cntEntry/@lPageUnit + 1
	End

End
--SortMin and SortMax range
Select
	@ixSortPageMin = (@ixPage-1)*@lPageUnit+1
Select
	@ixSortPageMax = @ixSortPageMin+@lPageUnit-1		


--Clean up the paging table
Delete From 
	#tblTmpEntryListPaging
Where
	ixSort < @ixSortPageMin
or
	ixSort > @ixSortPageMax		

------------------------------------
--Main Logic
------------------------------------

------------------------------------
--OutPut
------------------------------------
Select
	tae.ixArchiveEntry,
	convert(nvarchar(10),tae.dtCreate,111) as sPostDate,
	substring(tae.sEntryText,0,150) as sEntryTextFirstChunk
From	
	tdatArchiveEntry tae
Inner Join 
	#tblTmpEntryListPaging tgp
On 
	tgp.ixArchiveEntry = tae.ixArchiveEntry
order by
	tae.dtCreate desc
